#!/usr/bin/env python2
# coding: utf-8

import gi
gi.require_version("Gtk", "2.0")
gi.require_version('MatePanelApplet', '4.0')
gi.require_version('Bamf', '3')
 
from gi.repository import Gtk, GLib, GdkPixbuf, Gdk, GObject
from gi.repository import MatePanelApplet
from gi.repository import Gio
try:
    import sys
    import os
    import commands
    import gettext
    import traceback
    import time
    import gc
    import ctypes
    from ctypes import *
    import xdg.Config
    import keybinding
    import pointerMonitor
except Exception, e:
    print e
    sys.exit( 1 )
GObject.threads_init()

gdk = CDLL("libgdk-x11-2.0.so.0")
# i18n
gettext.install("kylin-menu", "/usr/share/locale")

NAME = _("Menu")
PATH = os.path.abspath( os.path.dirname( sys.argv[0] ) )

sys.path.append( os.path.join( PATH , "plugins") )

windowManager = os.getenv("DESKTOP_SESSION")
if not windowManager:
    windowManager = "MATE"
xdg.Config.setWindowManager( windowManager.upper() )

from execute import *

class MainWindow( object ):
    """This is the main class for the application"""

    def __init__( self, toggleButton, keybinder ):
        self.keybinder = keybinder
        self.path = PATH
        sys.path.append( os.path.join( self.path, "plugins") )

        self.de = "mate"

        self.toggle = toggleButton
        # Load UI file and extract widgets   
        builder = Gtk.Builder()
        builder.add_from_file(os.path.join( self.path, "mate-menu.glade" ))
        self.window     = builder.get_object( "mainWindow" )
        self.eventbox   = builder.get_object( "eventbox1" )
        self.paneholder = builder.get_object( "paneholder" )
        self.border     = builder.get_object( "border" )
        
        builder.connect_signals(self)

        self.borderwidth = 5
        self.border.set_padding( self.borderwidth, self.borderwidth, self.borderwidth, self.borderwidth )
        
	defaultStyle = self.getDefaultStyle()
        if defaultStyle is not None:
            self.window.modify_bg( Gtk.StateType.NORMAL, defaultStyle.lookup_color('kylinside_color')[1] )
            self.eventbox.modify_bg( Gtk.StateType.NORMAL, defaultStyle.lookup_color('kylinmenu_color')[1] )
        else:
            self.window.modify_bg( Gtk.StateType.NORMAL, Gdk.color_parse( "#155670" ) )
            self.eventbox.modify_bg( Gtk.StateType.NORMAL, Gdk.color_parse("#3b9dc5") )

        self.window.connect( "key-press-event", self.onKeyPress )
        self.window.connect( "focus-in-event", self.onFocusIn )
        self.loseFocusId = self.window.connect( "focus-out-event", self.onFocusOut )
        self.loseFocusBlocked = False

        self.offset = 0

        self.tooltips = Gtk.Tooltips()
        self.tooltips.enable()

        self.PopulatePlugins()            
#        GLib.timeout_add( 200, self.PopulatePlugins )
        self.firstTime = True;

    def PopulatePlugins( self ):
        PluginPane = Gtk.EventBox()
        PluginPane.show()
        PaneLadder = Gtk.VBox( False, 0 )
        PluginPane.add( PaneLadder )
        ImageBox = Gtk.EventBox()
        ImageBox.show()

        self.plugins = {}
        self.pluginlist = {'kylinmenu'}

        for plugin in self.pluginlist:
            if plugin in self.plugins:
                print u"Duplicate plugin in list: ", plugin
                continue

        if plugin == "kylinmenu":
            try:
                X = __import__( plugin )
                # If no parameter passed to plugin it is autonomous
                if X.pluginclass.__init__.func_code.co_argcount == 1:
                    MyPlugin = X.pluginclass()
                else:
                    # pass mateMenu and togglebutton instance so that the plugin can use it
                    MyPlugin = X.pluginclass( self, self.toggle, self.de )

                #if not MyPlugin.icon:
                #    MyPlugin.icon = "mate-logo-icon.png"

            except Exception, e:
                print u"Unable to load " + plugin + " plugin :-("
                print e

            MyPlugin.content_holder.show()

            VBox1 = Gtk.VBox( False, 0 )
            VBox1.show()
            #Add plugin to Plugin Box under heading button
            MyPlugin.content_holder.reparent( VBox1 )

            #Add plugin to main window
            PaneLadder.pack_start( VBox1 , True, True, 0)
            PaneLadder.show()

            if MyPlugin.window:
                MyPlugin.window.destroy()

            try:
                if hasattr( MyPlugin, 'do_plugin' ):
                    MyPlugin.do_plugin()

                heightPath = os.path.join(GLib.get_home_dir(), ".windowHeight")
                if os.path.exists(heightPath):
                    f = open(heightPath, "r")
                    lines = f.readlines()
                    length = lines[0]
                    MyPlugin.windowHeight = int(length)
                    f.close()
                MyPlugin.content_holder.set_size_request(345, MyPlugin.windowHeight )
            except Exception, e:
                print u"111111111111111111111111111"

            self.plugins[plugin] = MyPlugin

        self.paneholder.pack_start( ImageBox, False, False, 0 )
        self.paneholder.pack_start( PluginPane, False, False, 0 )
        self.tooltips.disable()

    # A little hacky but works
    def getDefaultStyle( self ):
        widget = Gtk.EventBox()
        widget.show()
        return Gtk.rc_get_style(widget)

    def setTooltip( self, widget, tip, tipPrivate = None ):
        self.tooltips.set_tip( widget, tip, tipPrivate )

    def onKeyPress( self, widget, event ):
        if event.keyval == Gdk.KEY_Escape:
            self.hide()
            return True
        return False

    def show( self ):
            
        for plugin in self.plugins.values():
            if hasattr( plugin, "onShowMenu" ):
                plugin.onShowMenu()

        self.window.present()
        
        self.window.window.focus( Gdk.CURRENT_TIME )

        for plugin in self.plugins.values():
            if hasattr( plugin, "changeTab" ):
                plugin.changeTab( 0 )


        Gdk.flush()

    def hide( self, forceHide = False ):
        for plugin in self.plugins.values():
            if hasattr( plugin, "onHideMenu" ):
                plugin.onHideMenu()
                
        self.window.hide()
        
    def onFocusIn( self, *args ):
        if self.loseFocusBlocked:
            self.window.handler_unblock( self.loseFocusId )
            self.loseFocusBlocked = False

        return False  
        
    def onFocusOut( self, *args):            
        if self.window.get_visible():
            self.hide()
        return False
        
    def stopHiding( self ):
        if not self.loseFocusBlocked:
            self.window.handler_block( self.loseFocusId )
            self.loseFocusBlocked = True

class MenuWin( object ):
    def __init__( self, applet, iid ):
        self.applet = applet        

        self.createPanelButton()
        self.applet.set_flags( MatePanelApplet.AppletFlags.EXPAND_MINOR )
        self.applet.connect( "button-press-event", self.showMenu )
        self.applet.connect("enter-notify-event", self.enter_notify)
        self.applet.connect("leave-notify-event", self.leave_notify)
        GLib.timeout_add( 500, self.InitMenu )

#        self.applet.set_flags( MatePanelApplet.AppletFlags.EXPAND_MINOR )
#        self.applet.connect( "button-press-event", self.showMenu )
#        self.applet.connect("enter-notify-event", self.enter_notify)
#        self.applet.connect("leave-notify-event", self.leave_notify)
#        self.mainwin = MainWindow( self.button_box, self.keybinder )
#        self.mainwin.window.connect( "map-event", self.onWindowMap )
#        self.mainwin.window.connect( "unmap-event", self.onWindowUnmap )
#        self.mainwin.window.connect( "realize", self.onRealize )
#        self.mainwin.window.connect( "size-allocate", lambda *args: self.positionMenu() )

#        self.bind_hot_key()
#        self.applet.set_can_focus(False)
#
#        self.pointerMonitor = pointerMonitor.PointerMonitor()
#        self.pointerMonitor.connect("activate", self.onPointerOutside)
#        self.openState = True

    def InitMenu( self ):
        self.keybinder = keybinding.GlobalKeyBinding()
        self.hotkeyText =  "Super_L"
        self.mainwin = MainWindow( self.button_box, self.keybinder )
        self.mainwin.window.connect( "map-event", self.onWindowMap )
        self.mainwin.window.connect( "unmap-event", self.onWindowUnmap )
        self.mainwin.window.connect( "realize", self.onRealize )
        self.mainwin.window.connect( "size-allocate", lambda *args: self.positionMenu() )

        self.bind_hot_key()
        self.applet.set_can_focus(False)

        self.pointerMonitor = pointerMonitor.PointerMonitor()
        self.pointerMonitor.connect("activate", self.onPointerOutside)
        self.openState = True
        
    def onWindowMap( self, *args ):
        self.applet.set_state( Gtk.StateType.SELECTED )
        self.keybinder.set_focus_window( self.mainwin.window.window )
        self.pointerMonitor.grabPointer()
        return False
        
    def onWindowUnmap( self, *args ):
        self.applet.set_state( Gtk.StateType.NORMAL )
        self.keybinder.set_focus_window()
        self.pointerMonitor.ungrabPointer()
        return False
        
    def onRealize( self, *args):
        self.pointerMonitor.addWindowToMonitor( self.mainwin.window.window )
        self.pointerMonitor.addWindowToMonitor( self.applet.window )
        self.pointerMonitor.start()
        return False
     
    def onPointerOutside(self, *args):
        self.mainwin.hide()
        return True

    def onBindingPress(self, binder):
        self.toggleMenu()
        return True

    def enter_notify(self, applet, event):
        self.do_image(True)

    def leave_notify(self, applet, event):
		# Hack for mate-panel-test-applets focus issue (this can be commented)
        if event.state & Gdk.ModifierType.BUTTON1_MASK and applet.state & Gtk.StateType.SELECTED:
            if event.x >= 0 and event.y >= 0 and event.x < applet.window.get_width() and event.y < applet.window.get_height():
                self.mainwin.stopHiding()
                
        self.do_image(False)

    def do_image(self, saturate):
        if saturate:
            #self.button_icon.set_from_icon_name("start-here", Gtk.IconSize.DND)
            pixbuf = GdkPixbuf.Pixbuf.new_from_file("/usr/lib/ubuntu-mate/mate-menu/start-hover.png")
        else:
            #self.button_icon.set_from_icon_name("start-here", Gtk.IconSize.DND)
            pixbuf = GdkPixbuf.Pixbuf.new_from_file("/usr/lib/ubuntu-mate/mate-menu/start.png")
        self.button_icon.set_from_pixbuf(pixbuf)

    def createPanelButton( self ):
        self.button_icon = Gtk.Image.new_from_file("/usr/lib/ubuntu-mate/mate-menu/start.png")
        self.button_icon.set_tooltip_text(_("Start"))
        #if self.applet.get_orient() == MatePanelApplet.AppletOrient.UP or self.applet.get_orient() == MatePanelApplet.AppletOrient.DOWN:
        self.button_box = Gtk.HBox()
        self.button_box.set_size_request(50, -1)
        self.button_box.pack_start( self.button_icon, True, True, 0 )
        self.button_icon.set_padding( 0, 0 )

        self.button_box.show_all()

        self.applet.add( self.button_box )
        self.applet.set_background_widget( self.applet )

    def bind_hot_key (self):
        try:
            if self.hotkeyText != "":
                self.keybinder.grab( self.hotkeyText )
            self.keybinder.connect("activate", self.onBindingPress)
            self.keybinder.start()
            # Binding menu to hotkey
            print "Binding to Hot Key: " + self.hotkeyText
            
        except Exception, cause:
            print "** WARNING ** - Menu Hotkey Binding Error"
            print "Error Report :\n", str(cause)
            pass

    def reloadSettings( self, *args ):
        self.loadSettings()

    def showMenu( self, widget=None, event=None ):
        if self.openState:
            GLib.timeout_add( 200, self.updateState )
        if event == None or event.button == 1:
            if self.openState:
                self.toggleMenu()
                self.openState = False
        elif event.button == 2:
            self.mainwin.hide( True )

    def updateState( self ):
        self.openState = True

    def toggleMenu( self ):
        if self.applet.state & Gtk.StateType.SELECTED:
            self.mainwin.hide( True )
        else:
            #self.button_icon.set_from_icon_name( "start-here", Gtk.IconSize.DND )
            pixbuf = GdkPixbuf.Pixbuf.new_from_file("/usr/lib/ubuntu-mate/mate-menu/start-click.png")
            self.button_icon.set_from_pixbuf(pixbuf)
            self.mainwin.show()

    def positionMenu( self ):
        # Get our own dimensions & position
        ourWidth  = self.mainwin.window.get_size()[0]
        ourHeight = self.mainwin.window.get_size()[1] + self.mainwin.offset

        x = c_int()
        y = c_int()
        # Get the dimensions/position of the widgetToAlignWith
        gdk.gdk_window_get_origin(hash(self.applet.window), byref(x), byref(y))
        entryX = x.value
        entryY = y.value

        entryWidth, entryHeight =  self.applet.get_allocation().width, self.applet.get_allocation().height
        entryHeight = entryHeight + self.mainwin.offset

        # Get the screen dimensions
        screenHeight = Gdk.Screen.height()
        screenWidth = Gdk.Screen.width()
        if self.applet.get_orient() == MatePanelApplet.AppletOrient.UP or self.applet.get_orient() == MatePanelApplet.AppletOrient.DOWN:
            if entryX + ourWidth < screenWidth or  entryX + entryWidth / 2 < screenWidth / 2:
            # Align to the left of the entry
                newX = entryX
            else:
                # Align to the right of the entry
                newX = entryX + entryWidth - ourWidth

            if entryY + entryHeight / 2 < screenHeight / 2:
                # Align to the bottom of the entry
                newY = entryY + entryHeight
            else:
                newY = entryY - ourHeight
        else:
            if entryX + entryWidth / 2 < screenWidth / 2:
                # Align to the left of the entry
                newX = entryX + entryWidth
            else:
                # Align to the right of the entry
                newX = entryX - ourWidth

            if entryY + ourHeight < screenHeight or entryY + entryHeight / 2 < screenHeight / 2:
                # Align to the bottom of the entry
                newY = entryY
            else:
                newY = entryY - ourHeight + entryHeight
        # -"Move window"
        self.mainwin.window.move( newX, newY )

def applet_factory( applet, iid, data ):
    MenuWin( applet, iid )
    applet.show()
    return True

def quit_all(widget):
    Gtk.main_quit()
    sys.exit(0)

MatePanelApplet.Applet.factory_main("MateMenuAppletFactory", True,
                                    MatePanelApplet.Applet.__gtype__,
                                    applet_factory, None)
